"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
var getPath = function getPath(obj, arPath) {
  var res = obj;
  var _iterator = _createForOfIteratorHelper(arPath),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var sub = _step.value;
      res = res[sub];
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return res;
};
var setPath = function setPath(obj, _arPath, data) {
  if (1 < _arPath.length) {
    var subPath = _arPath.slice(0, _arPath.length - 1);
    var lastSubPath = _arPath[_arPath.length - 1];
    var subObj = getPath(obj, subPath);
    subObj[lastSubPath] = data;
  } else if (_arPath.length === 1) {
    obj[_arPath[0]] = data;
  }
};
var getQueryPaths = function getQueryPaths(query) {
  var definitions = query.definitions;
  var pathEdges = [];
  var pathPageInfo = [];
  var pathItem = [];
  var haveEdges = false;
  var havePageInfo = false;
  //let haveItem = false

  //console.log(query.definitions)
  var _iterator2 = _createForOfIteratorHelper(definitions),
    _step2;
  try {
    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var def = _step2.value;
      if (def.operation === "query") {
        var _iterator3 = _createForOfIteratorHelper(def.selectionSet.selections),
          _step3;
        try {
          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var sel = _step3.value;
            var directiveConnection = false;
            var _iterator4 = _createForOfIteratorHelper(sel.directives),
              _step4;
            try {
              for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
                var dir = _step4.value;
                if (dir.name.value === "connection") {
                  directiveConnection = true;
                  break;
                }
              }
            } catch (err) {
              _iterator4.e(err);
            } finally {
              _iterator4.f();
            }
            if (!directiveConnection) {
              throw new Error('Query must contain directive @connection(key: "????")');
            }
            if (directiveConnection) {
              pathEdges.push(sel.name.value);
              pathPageInfo.push(sel.name.value);
              var _iterator5 = _createForOfIteratorHelper(sel.selectionSet.selections),
                _step5;
              try {
                for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
                  var sel2 = _step5.value;
                  if (sel2.name.value === "edges") {
                    pathEdges.push(sel2.name.value);
                    haveEdges = true;
                    var _iterator6 = _createForOfIteratorHelper(sel2.selectionSet.selections),
                      _step6;
                    try {
                      for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
                        var sel3 = _step6.value;
                        if (sel3.name.value === "node") {
                          pathItem.push(sel3.name.value);
                          //haveItem = true
                          break;
                        }
                      }
                    } catch (err) {
                      _iterator6.e(err);
                    } finally {
                      _iterator6.f();
                    }
                  } else if (sel2.name.value === "pageInfo") {
                    pathPageInfo.push(sel2.name.value);
                    havePageInfo = true;
                  }
                  if (haveEdges && havePageInfo) {
                    break;
                  }
                }
              } catch (err) {
                _iterator5.e(err);
              } finally {
                _iterator5.f();
              }
            }
            if (haveEdges && havePageInfo) {
              break;
            }
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
      }
      if (haveEdges && havePageInfo) {
        break;
      }
    }

    //const fnGetEdges = (data) => data.feedConnection.edges
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }
  var fnGetEdges = function fnGetEdges(data) {
    return getPath(data, pathEdges);
  };
  //const fnSetEdges = (data, edges) => { data.feedConnection.edges = edges }
  var fnSetEdges = function fnSetEdges(data, edges) {
    setPath(data, pathEdges, edges);
  };
  //  const fnGetItem = (edge) => edge.node
  var fnGetItem = function fnGetItem(edge) {
    return getPath(edge, pathItem);
  };
  var fnGetPageInfo = function fnGetPageInfo(data) {
    return getPath(data, pathPageInfo);
  };
  var fnGetArray = function fnGetArray(data) {
    return fnGetEdges(data).map(function (o) {
      return fnGetItem(o);
    });
  };
  // const fnGetArray = data => {
  //   console.log(`fnGetArray`)
  //   console.log(data)
  //   console.log(fnGetEdges(data))
  //   console.log(fnGetEdges(data).map(o => fnGetItem(o)))

  //   return fnGetEdges(data).map(o => fnGetItem(o))
  // }
  var fnJoinResults = function fnJoinResults(currData, prevData) {
    return fnSetEdges(currData, fnGetEdges(prevData).concat(fnGetEdges(currData)));
  };
  return {
    //fnGetEdges,
    //fnSetEdges,
    fnJoinResults: fnJoinResults,
    //fnGetItem,
    fnGetArray: fnGetArray,
    fnGetPageInfo: fnGetPageInfo
  };
};
var _default = exports["default"] = getQueryPaths;