"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = require("react");
var _utils = require("./utils");
var _excluded = ["variables"];
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var initialState = {
  loading: true,
  data: null,
  error: null
};
function reducer(state, action) {
  switch (action.type) {
    case "start":
      {
        return _objectSpread(_objectSpread({}, state), {}, {
          loading: true
        });
      }
    case "success":
      return {
        //...state,
        loading: false,
        data: action.payload,
        error: null
      };
    case "error":
      return _objectSpread(_objectSpread({}, state), {}, {
        loading: false,
        error: action.payload
      });
    default:
      throw new Error("useQuery/reducer(): Unknown action.type ".concat(action.type));
  }
}

// options = { query, variables }
var useQuery = function useQuery(client, options) {
  var fnGetData = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function (data) {
    return data;
  };
  var _useReducer = (0, _react.useReducer)(reducer, initialState),
    _useReducer2 = _slicedToArray(_useReducer, 2),
    state = _useReducer2[0],
    dispatch = _useReducer2[1];
  var memoOptions = (0, _react.useMemo)(function () {
    // if (process.env.NODE_ENV==='development') {
    //   console.log('useMemo memoRestOptions')
    // }      
    var variables = options.variables,
      restOptions = _objectWithoutProperties(options, _excluded);
    return _objectSpread({
      variables: variables || {}
    }, restOptions);
  },
  // eslint-disable-next-line
  (0, _utils.options2arr)(options));
  var observableQuery = (0, _react.useMemo)(function () {
    var _observable;
    try {
      _observable = client.watchQuery(_objectSpread(_objectSpread({}, memoOptions), {}, {
        fetchPolicy: "network-only"
      }));
    } catch (errWatch) {
      dispatch({
        type: "error",
        payload: errWatch
      });
    }
    return _observable;
  }, [client, memoOptions]);
  (0, _react.useEffect)(function () {
    if (!observableQuery) {
      return;
    }
    var s = observableQuery.subscribe(function (resultNext) {
      var newData = resultNext.data;
      if (fnGetData) {
        newData = fnGetData(resultNext.data);
      }
      if (Array.isArray(newData)) {
        //newData = [ ...newData ]
        newData = newData.slice();
      } else if (!!newData && newData.constructor === Object) {
        //newData = { ...newData0 }
        newData = Object.assign({}, newData);
      }
      dispatch({
        type: 'success',
        payload: newData
      });
    }, function (err) {
      dispatch({
        type: 'error',
        payload: err
      });
    });
    return function () {
      return s.unsubscribe();
    };
  }, [observableQuery, fnGetData]);
  return {
    loading: state.loading,
    data: state.data,
    error: state.error
  };
};
var _default = exports["default"] = useQuery;